// -*- c++ -*-
//  Generated by gtkmmproc from ./../canvas-line.gen_h -- DO NOT MODIFY!
#ifndef _GNOMEMM_CANVAS_LINE_H
#define _GNOMEMM_CANVAS_LINE_H

/* $Id: canvas-line.gen_h,v 1.30 2000/08/24 15:57:25 kenelson Exp $ */

/* canvas-line.h
 *
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <vector>
#include <gnome--/canvas-item.h>
#include <libgnomeui/gnome-canvas-line.h>
#include <libgnomeui/gnome-canvas-util.h>

namespace Gnome {
class CanvasLine;
class CanvasLine_Class;
}
namespace Gtk { Gnome::CanvasLine *wrap (GnomeCanvasLine *o); }
namespace Gnome
{

class GnomeGroup;

class gpoint
{
public:
  gpoint(double xx = 0, double yy = 0) : x(xx), y(yy) {};
  double x;
  double y;
};

// Sample use of Gnome_CanvasPoints :

//   Gnome_CanvasPoints points;
//
//   points.push_back(gpoint(0, 0));
//   points.push_back(gpoint(100,0));
//   points.push_back(gpoint(0,100));
//   points.push_back(gpoint(100,100));
//
//   line = new Gnome_CanvasLine(&m_canvasgroup,
// 				"points", points.gtkobj(),
// 				"fill_color", "black",
// 				"width_units", 1.0,
// 				"cap_style", GDK_CAP_ROUND,
// 				NULL);

class CanvasPoints : public vector<gpoint>
{
 public:
  CanvasPoints(size_type nbpoints = 0);
  CanvasPoints(GnomeCanvasPoints *castitem);
  ~CanvasPoints();

  const GnomeCanvasPoints* gtkobj() const { return _gtkobj(); }
  GnomeCanvasPoints* gtkobj() { return _gtkobj(); }

 protected:
  GnomeCanvasPoints* _gtkobj() const;
  mutable GnomeCanvasPoints *points_;
  mutable bool owned;
};

class CanvasLine : public CanvasItem
{

public:
  typedef CanvasLine          CppObjectType;
  typedef CanvasLine_Class    CppClassType;
  typedef GnomeCanvasLine           BaseObjectType;
  typedef GnomeCanvasLineClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType canvas_line_class;

  CanvasLine(const CanvasLine&);
  CanvasLine& operator=(const CanvasLine&); // not implemented

protected:
  void   initialize_class();
  explicit CanvasLine(GnomeCanvasLine *castitem);

public:
  static GtkType get_type();
  GnomeCanvasLine* gtkobj()             { return (GnomeCanvasLine*)(gtkobject); }
  const GnomeCanvasLine* gtkobj() const { return (GnomeCanvasLine*)(gtkobject); }
  static bool isA(Gtk::Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~CanvasLine();

private:

public:
  CanvasLine();



  CanvasLine(const CanvasGroup &parent,
		   const gchar *first_arg_name,
		   ...);
  CanvasLine(const CanvasGroup &parent);


  CanvasLine& set_points          (const CanvasPoints &points);
  CanvasLine& set_fill_color      (const string &colorname);
  CanvasLine& set_fill_color_gdk  (const Gdk_Color &color);
  CanvasLine& set_fill_stipple    (const Gdk_Window &window);
  CanvasLine& set_width_pixels    (guint width);
  CanvasLine& set_width_units     (gdouble units);
  CanvasLine& set_cap_style       (GdkCapStyle style);
  CanvasLine& set_join_style      (GdkJoinStyle style);
  CanvasLine& set_line_style      (GdkLineStyle style);
  CanvasLine& set_first_arrowhead (bool firstarrowhead);
  CanvasLine& set_last_arrowhead  (bool lastarrowhead);
  CanvasLine& set_smooth          (bool smooth);
  CanvasLine& set_spline_steps    (guint nbsteps);
  CanvasLine& set_arrow_shape_a   (gdouble arrowshape);
  CanvasLine& set_arrow_shape_b   (gdouble arrowshape);
  CanvasLine& set_arrow_shape_c   (gdouble arrowshape);

public:

protected:
  // impl functions

};

}

#endif
